=== src/OpenMesh/Apps/mconvert/CMakeLists.txt ===
include (VCICommon)

vci_add_executable (mconvert mconvert.cc)

target_link_libraries (mconvert
  OpenMeshCore
  OpenMeshTools
)
