=== debian/changelog ===
openmesh (11.0.0-2) unstable; urgency=medium

  * Team upload.
  * No change source-only upload for testing migration.

 -- Boyuan Yang <byang@debian.org>  Sat, 23 Nov 2024 18:24:26 -0500

openmesh (11.0.0-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Sun, 10 Nov 2024 20:53:37 -0800
