=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DOPENMESH_DOCS=ON \
		-DBUILD_APPS=ON \
		-DOpenGL_GL_PREFERENCE=GLVND

override_dh_auto_build-arch:
	dh_auto_build -a

override_dh_auto_build-indep:
	$(MAKE) -C obj-$(DEB_HOST_GNU_TYPE) doc

override_dh_auto_test-indep:
	true

# I namespace all executables with "OpenMesh-"
# Their default names are just too generic
override_dh_auto_install-arch:
	dh_auto_install
	for f in debian/tmp/usr/bin/*; do mv $$f `dirname $$f`/OpenMesh-`basename $$f`; done

override_dh_auto_install-indep:
	true
