=== debian/watch ===
version=4
https://www.graphics.rwth-aachen.de/software/openmesh/download/ \
.*/media/openmesh_static/Releases/(?:[0-9\.]*)/OpenMesh-(\d\S+)\.tar\.gz
